#!/usr/local/bin/perl

#foreach (keys %vars) {
#    print "$_=$vars{$_}\n";
#}

sub processfilename {
    local($fname, $dosubs) = @_;
    
    open($fname, "<".$fname) || return ;
    &processfile($fname, $fname, $dosubs);
    close($fname);
}

sub processfile {
    local($FILE, $fname, $dosubs) = @_;
    local($includename);
    local($macroname);

    while (<$FILE>) {

	if ($dosubs == 1) {
	    s'&'&amp;'g;       #' 
	    s'<'&lt;'g;        #'
	    s'>'&gt;'g;        #'
	    s'"'&quot;'g;      #'
	}
      loop: {

	s/\$FILE/$htmlname/eg;

	  /^\#definemacro/ && do {
	    ($macroname, $value) = /\#definemacro\s+(\w+)\s+(.*)/;
	    $macros{$macroname} = "$value";
	    #print "definemacro $macroname in $fname\n";
	    last loop;
	};

	/^\#define/ && do { 
	    ($var, $value) = /\#define\s+(\w+)\s+(.*)/;
	    $value =~ s'\$(\w+)'$vars{$1}'eg;   #'
	    $vars{$var} = "$value";
    	    #print "define $var as :$vars{$var}:\n";
	    last loop;
	};

	/^\#include\s+/ && do {
	    ($includename) = /\#include\s+([\w\._\-\$\/]+)/;
	    $includename =~ s'\$(\w+)'$vars{$1}'eg;   #'
	    # print "include $includename\n";
	    if (&processfilename($includename) == 1) {
		last loop;
	    }
	};

	/^\#includejava\s+/ && do {
	    ($includename) = /\#includejava\s+([\w\._\-\$\/]+)/;
	    $includename =~ s'\$(\w+)'$vars{$1}'eg;   #'
	    # print "includejava $includename\n";
	    if (&processfilename($includename, 1) == 1) {
		last loop;
	    }
	};

	/^\#ifdef/ && do {
	    ($varname) = /\#ifdef\s+(\w+)/;
	    if (!defined($vars{$varname})) {
		while (<$FILE>) {
		    last if /^\#endif/;
		}
	    }
	    
	    last loop;
	};

	/^\#endif/ && do {
	    last loop;
	};

	/^\#usemacro/ && do {
	    ($macroname) = /\#usemacro\s+(\w+)/;
	    undef %localvars;
	    while (<$FILE>) {
		last if /\s*\)\s*$/;
		($var, $value) = /\s*(\w+)\s+(.*)/;
		$value =~ s'\$(\w+)'defined($localvars{$1}) ? $localvars{$1} :$vars{$1}'eg;  #'
		$localvars{$var} = $value;
	    }
	    #print "usemacro $macroname in $fname\n"; 
	    $_ = $macros{$macroname};
	    s'\$(\w+)'defined($localvars{$1}) ? $localvars{$1} :$vars{$1}'eg;   #'
	    print;
	    last loop;
	};

	s'\$(\w+)'$vars{$1}'eg;   #'
	    print;
	}  # end of loop
    }
}


# process the "-Dvar value" switches on the command line
while ($ARGV[0] =~ /^-D(\w+)/) {
    shift;
    $vars{$1} = $ARGV[0];
    shift;
}

foreach $file (@ARGV) {
	$htmlname = substr ($file, 0, index ($file, 'mem4')) . 'html';
	print htmlname
	&processfilename($file);
}
